<?php

namespace Magento\Placetgroup\Block\Payment;

use Magento\Checkout\Model\Session;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;
use Magento\Placetgroup\Model\PlacetgroupPaymentFactory;

class Start extends Template
{
    /**
     * @var PlacetgroupPaymentFactory\
     */
    private $placetPaymentFactory;

    /**
     * @var Session
     */
    private $session;

    /**
     * Construct function.
     *
     * @param Context $context
     * @param PlacetPaymentFactory $placetPaymentFactory
     * @param Session $session
     * @param array $data
     */
    public function __construct(
        Context $context,
        PlacetgroupPaymentFactory $placetPaymentFactory,
        Session $session,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->placetPaymentFactory = $placetPaymentFactory;
        $this->session = $session;
    }

    /**
     * @return string
     */
    public function getFormActionUrl()
    {
        $payment = $this->placetPaymentFactory->create();
        $payment->getLiisiAPI();

        return $payment->getUrl();
    }

    /**
     * @return array
     */
    public function getFormFields()
    {
        return $this->placetPaymentFactory->create()->getFormFields(
            $this->session->getLastRealOrder(),
            $this->getUrl('placetgroup/payment/index')
        );
    }
}
