<?php

namespace Magento\Placetgroup\Controller\Payment;

use Magento\Checkout\Model\Session;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\Result\Redirect;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Controller\ResultInterface;
use Throwable;
use Magento\Placetgroup\Helper\Response\Handler;
use Magento\Placetgroup\Model\PlacetgroupPayment;

class Index extends Action
{
    /**
     * @var Session
     */
    private $checkoutSession;

    /**
     * @var Handler
     */
    private $responseHandlerHelper;

    /**
     * Construct function.
     *
     * @param Context $context
     * @param Handler $responseHandlerHelper
     * @param Session $checkoutSession
     */
    public function __construct(Context $context, Handler $responseHandlerHelper, Session $checkoutSession)
    {
        parent::__construct($context);

        $this->responseHandlerHelper = $responseHandlerHelper;
        $this->checkoutSession = $checkoutSession;
    }

    /**
     * @inheritdoc
     */
    public function execute()
    {
        return $this->handleRedirectRequest();
        if ($this->responseHandlerHelper->verifyRequest($request = $this->getRequest())) {
            if ($this->responseHandlerHelper->isAutoRequest($request)) {
                return $this->handleAutoRequest();
            }

            return $this->handleRedirectRequest();
        }

        return $this->resultRedirectFactory->create()->setPath('/');
    }

    /**
     * @return ResultInterface
     */
    private function handleAutoRequest()
    {
        var_dump(4);die;
        $requestType = $this->responseHandlerHelper->getRequestType($this->getRequest());

        try {
            $response = $this->resultFactory->create(ResultFactory::TYPE_RAW);

            if ($requestType === PlacetgroupPayment::RESPONSE_1111) {
                $this->responseHandlerHelper->setOrderAsProcessing($this->getRequest());
            } else if ($requestType === PlacetgroupPayment::RESPONSE_1911) {
                $this->responseHandlerHelper->setOrderAsCancelled($this->getRequest());
            }

            return $response->setHttpResponseCode(200);
        } catch (Throwable $exception) {
            return $response->setHttpResponseCode(409);
        }
    }

    /**
     * @return Redirect
     */
    private function handleRedirectRequest()
    {
        $status = $this->getRequest()->getParam('status') ? $this->getRequest()->getParam('status') : 'error';

        try {
            if ($status === 'success') {
                $order = $this->responseHandlerHelper->loadOrderFromRequest($this->getRequest());

                $this->checkoutSession->setLastQuoteId($order->getQuoteId());
                $this->checkoutSession->setLastSuccessQuoteId($order->getQuoteId());
                $this->checkoutSession->setLastOrderId($order->getId());
                $this->checkoutSession->setLastRealOrderId($order->getIncrementId());
                $this->checkoutSession->setLastOrderStatus($order->getStatus());
                return $this->resultRedirectFactory->create()->setPath('checkout/onepage/success');
            } else {
                $this->responseHandlerHelper->setOrderAsCancelled($this->getRequest());
            }
        } catch (Throwable $exception) {
            return $this->resultRedirectFactory->create()->setPath('checkout/onepage/failure');
        }

        return $this->resultRedirectFactory->create()->setPath('checkout/onepage/failure');
    }
}
