<?php

namespace Magento\Placetgroup\Model;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\Asset\Repository;

class PlacetgroupConfigProvider implements ConfigProviderInterface
{
    /**
     * @var Repository
     */
    protected $_assetRepo;

    /**
     * @var UrlInterface
     */
    private $urlBuilder;

    /**
     * Construct function.
     *
     * @param Repository $assetRepo
     * @param UrlInterface $urlBuilder
     */
    public function __construct(Repository $assetRepo, UrlInterface $urlBuilder)
    {
        $this->_assetRepo = $assetRepo;
        $this->urlBuilder = $urlBuilder;
    }

    /**
     * {@inheritdoc}
     */
    public function getConfig()
    {
        $config = [
            'payment' => [
                'placetgroup' => [
                    'paymentAcceptanceMarkSrc' => $this->_assetRepo->getUrl('Magento_Placetgroup::images/logo.png'),
                    'redirectUrl' => $this->urlBuilder->getUrl('placetgroup/payment/start'),
                ],
            ],
        ];

        return $config;
    }
}
